/**
   This version of the Country class
   implements the Comparable<T> interface.

   A generic sorting algorithm can use
   Country's compareTo() method to sort
   a list of Country objects.

   And we could also define a Comparator<Country> object
   for this Country class and then use a generic sorting
   method that works with a Comparator<T> object.
*/
public class Country implements Comparable<Country>
{
   public String name;
   public int population;
   public int area;

   public Country(String name, int population, int area)
   {
      this.name = name;
      this.population = population;
      this.area = area;
   }


   @Override public String toString()
   {
      return "[" + name + ", " + population + ", " + area + "]";
   }


   /**
      If you change the definition of this compareTo() method,
      then you change the way a generic sorting method will sort
      lists of Country objects.
   */
   @Override public int compareTo(Country that)
   {
      if (! this.name.equals(that.name) )
      {
         return this.name.compareTo(that.name);
      }
      else if (this.population != that.population)
      {
         return this.population - that.population;
      }
      else
      {
         return this.area - that.area;
      }
   }
}
